﻿// <auto-generated />
using System;
using Ito.Software.Technical.Test.Infrastructure.SqlDb.Context;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;

#nullable disable

namespace Ito.Software.Technical.Test.Infrastructure.SqlDb.Migrations
{
    [DbContext(typeof(ItoSoftwareDbContext))]
    [Migration("20220823130117_FixingProductAK")]
    partial class FixingProductAK
    {
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "6.0.8")
                .HasAnnotation("Relational:MaxIdentifierLength", 128);

            SqlServerModelBuilderExtensions.UseIdentityColumns(modelBuilder, 1L, 1);

            modelBuilder.Entity("Ito.Software.Technical.Test.Domain.Models.Customer.CustomerModel", b =>
                {
                    b.Property<int>("CustomerId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int");

                    SqlServerPropertyBuilderExtensions.UseIdentityColumn(b.Property<int>("CustomerId"), 1L, 1);

                    b.Property<string>("CustomerName")
                        .IsRequired()
                        .HasMaxLength(40)
                        .HasColumnType("nvarchar(40)");

                    b.Property<string>("Phone")
                        .HasMaxLength(20)
                        .HasColumnType("nvarchar(20)");

                    b.HasKey("CustomerId");

                    b.HasAlternateKey("CustomerName");

                    b.ToTable("Customers");
                });

            modelBuilder.Entity("Ito.Software.Technical.Test.Domain.Models.Order.OrderItemModel", b =>
                {
                    b.Property<int>("OrderId")
                        .HasColumnType("int");

                    b.Property<int>("ProductId")
                        .HasColumnType("int");

                    b.Property<int>("Quantity")
                        .HasColumnType("int");

                    b.Property<double>("UnitPrice")
                        .HasPrecision(12, 2)
                        .HasColumnType("float(12)");

                    b.HasKey("OrderId", "ProductId");

                    b.HasIndex("ProductId");

                    b.ToTable("OrderItems");
                });

            modelBuilder.Entity("Ito.Software.Technical.Test.Domain.Models.Order.OrderModel", b =>
                {
                    b.Property<int>("OrderId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int");

                    SqlServerPropertyBuilderExtensions.UseIdentityColumn(b.Property<int>("OrderId"), 1L, 1);

                    b.Property<int>("CustomerId")
                        .HasColumnType("int");

                    b.Property<DateTime>("OrderDate")
                        .HasColumnType("datetime2");

                    b.Property<string>("OrderNumber")
                        .IsRequired()
                        .HasMaxLength(10)
                        .HasColumnType("nvarchar(10)");

                    b.Property<double>("TotalAmount")
                        .HasPrecision(12, 2)
                        .HasColumnType("float(12)");

                    b.HasKey("OrderId");

                    b.HasAlternateKey("OrderNumber");

                    b.HasIndex("CustomerId");

                    b.ToTable("Orders");
                });

            modelBuilder.Entity("Ito.Software.Technical.Test.Domain.Models.Product.ProductModel", b =>
                {
                    b.Property<int>("ProductId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int");

                    SqlServerPropertyBuilderExtensions.UseIdentityColumn(b.Property<int>("ProductId"), 1L, 1);

                    b.Property<bool>("IsDiscontinued")
                        .HasColumnType("bit");

                    b.Property<string>("ProductName")
                        .IsRequired()
                        .HasMaxLength(50)
                        .HasColumnType("nvarchar(50)");

                    b.Property<int>("SupplierId")
                        .HasColumnType("int");

                    b.Property<double?>("UnitPrice")
                        .HasPrecision(12, 2)
                        .HasColumnType("float(12)");

                    b.HasKey("ProductId");

                    b.HasAlternateKey("ProductName");

                    b.HasAlternateKey("SupplierId", "ProductName");

                    b.ToTable("Products");
                });

            modelBuilder.Entity("Ito.Software.Technical.Test.Domain.Models.Supplier.SupplierModel", b =>
                {
                    b.Property<int>("SupplierId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int");

                    SqlServerPropertyBuilderExtensions.UseIdentityColumn(b.Property<int>("SupplierId"), 1L, 1);

                    b.Property<string>("CompanyName")
                        .IsRequired()
                        .HasMaxLength(40)
                        .HasColumnType("nvarchar(40)");

                    b.Property<string>("Phone")
                        .IsRequired()
                        .HasMaxLength(20)
                        .HasColumnType("nvarchar(20)");

                    b.HasKey("SupplierId");

                    b.HasAlternateKey("CompanyName");

                    b.ToTable("Suppliers");
                });

            modelBuilder.Entity("Ito.Software.Technical.Test.Domain.Models.Order.OrderItemModel", b =>
                {
                    b.HasOne("Ito.Software.Technical.Test.Domain.Models.Order.OrderModel", "Order")
                        .WithMany("OrderItems")
                        .HasForeignKey("OrderId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("Ito.Software.Technical.Test.Domain.Models.Product.ProductModel", "Product")
                        .WithMany("OrderItems")
                        .HasForeignKey("ProductId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Order");

                    b.Navigation("Product");
                });

            modelBuilder.Entity("Ito.Software.Technical.Test.Domain.Models.Order.OrderModel", b =>
                {
                    b.HasOne("Ito.Software.Technical.Test.Domain.Models.Customer.CustomerModel", "Customer")
                        .WithMany("Orders")
                        .HasForeignKey("CustomerId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Customer");
                });

            modelBuilder.Entity("Ito.Software.Technical.Test.Domain.Models.Product.ProductModel", b =>
                {
                    b.HasOne("Ito.Software.Technical.Test.Domain.Models.Supplier.SupplierModel", "Supplier")
                        .WithMany("Products")
                        .HasForeignKey("SupplierId");

                    b.Navigation("Supplier");
                });

            modelBuilder.Entity("Ito.Software.Technical.Test.Domain.Models.Customer.CustomerModel", b =>
                {
                    b.Navigation("Orders");
                });

            modelBuilder.Entity("Ito.Software.Technical.Test.Domain.Models.Order.OrderModel", b =>
                {
                    b.Navigation("OrderItems");
                });

            modelBuilder.Entity("Ito.Software.Technical.Test.Domain.Models.Product.ProductModel", b =>
                {
                    b.Navigation("OrderItems");
                });

            modelBuilder.Entity("Ito.Software.Technical.Test.Domain.Models.Supplier.SupplierModel", b =>
                {
                    b.Navigation("Products");
                });
#pragma warning restore 612, 618
        }
    }
}
